/**
 * Create an middleware function
 * @function apemanMiddlewareValidate
 * @param {Object} [options={}] - Optional settings
 * @returns {function}
 */
'use strict'

const co = require('co')
const debug = require('debug')('apeman:middleware:validate')

/** @lends apemanMiddlewareValidate */
function create (options = {}) {
  debug('created')
  return co.wrap(function * apemanMiddlewareValidate (ctx, next) {
    Object.assign(ctx, {
      validate  (schema, values) {
        return schema.validateToThrow(values, {
          assign: { status: 400 }
        })
      }
    })
    yield next()
  })
}

module.exports = create
